#ifndef STDIO_H
#define STDIO_H
#include <stdio.h>
#endif
#ifndef STDLIB_H
#define STDLIB_H
#include <stdlib.h>
#endif
#ifndef UNISTD_H
#define UNISTD_H
#include <unistd.h>
#endif

#ifndef HOMEMADE_SPEEDSTEP_H
#define HOMEMADE_SPEEDSTEP_H

#define VERSION "1.2"
#define FREQS "/sys/devices/system/cpu/cpufreq/policy0/scaling_available_frequencies"
#define MAXSPDPREFIX "/sys/devices/system/cpu/cpu"
#define MAXSPDSUFFIX "/cpufreq/scaling_max_freq"
#define CURTEMPPATH "/sys/devices/virtual/thermal/thermal_zone0/temp"
#define FILEERROR(operation, filename) fprintf(stderr, "error: couldn't %s %s\n       check that you have support for cpufreq\n       in your kernel and that the program is\n       running as root\n", operation, filename)

int changefreq(int threads, char* step); /* change max frequency of 'threads' to 'step', returns 0 on success */
int comparestrings(char *a, char *b); /* no security checks, make sure at least one of the char arrays is null terminated, returns 0 on success */
int getfilec(FILE *file, char arr[]); /* fills 'arr[]' with every character on '*file', returns the number of characters written to 'arr[]' as an int */
int powerof(int base, int exponent); /* returns power of base to the exponent */
int stringtoint(char number[], int length); /* returns an int of 'length' length from the string 'number', make sure string only has numbers in it or results will not be as expected */
int stringlength(char string[]); /* no security checks, make sure string is null terminated */
int splitstr(char** dest, char line[], int index1, int index2); /* add a substring from 'line' to 'dest'. index1 is offset of characters read from 'line' and index2 is the place in 'dest' to store the new char, returns int with new offset of characters read from 'line' + 1 **/
int countblanks(char line[]); /* */
void newlinetonullbyte(char string[]); /* */

int changefreq(int threads, char* step){
  int i;
  char filename[100];
  FILE* file;
  for (i=0; i < threads; i++){
    sprintf(filename, MAXSPDPREFIX"%d"MAXSPDSUFFIX, i);
    if ((file = fopen(filename, "w")) == NULL){
      return 1;
    }
    fprintf(file, "%s\n", step);
    fclose(file);
  }
  return 0;
}

int comparestrings(char *a, char *b){
  int c = 0;
  while(a[c] != '\0' && b[c] != '\0'){
    if(a[c] != b[c]){
      return 1;
    }
    c++;
  }
  return 0;
}

int getfilec(FILE *file, char arr[]){
  int c, i;
  i = 0;
  while((c = fgetc(file)) != EOF){
    arr[i] = c;
    i++;
  }
  arr[i] = '\0';
  return i;
}

int powerof(int base, int exponent){
  int i, result;
  if (exponent == 0){
    return result = 1;
  }
  result = base;
  for(i = 0; i < exponent - 1; i++){
    result *= base;
  }
  return result;
}

int stringtoint(char number[], int length){
  int j, result;
  result = 0;
  j = 0;
  while(length - 1 >= 0){
    result += ((int)number[length - 1] - '0') * (powerof(10, j));
    j++;
    length--;
  }
  return result;
}

int stringlength(char string[]){
  int i = 0;
  while(string[i] != '\0'){
    i++;
  }
  return i;
}

int splitstr(char** dest, char line[], int index1, int index2){
  int offset = index1;
  while (line[index1] != ' ' && index1 < stringlength(line)){
    index1++;
  }
  char* p = malloc(sizeof (char)*index1);
  int i;
  for(i = 0; i < index1 - offset; i++){
    p[i] = line[i + offset];
  }
  p[i] = '\0';
  dest[index2] = p;
  return index1 + 1;
}

int countblanks(char line[]){
  int i = 0;
  int j = 0;
  while(line[i] != '\0'){
    if (line[i] == ' '){
      j++;
    }
    i++;
  }
  return j;
}

void newlinetonullbyte(char string[]){
  int i = 0;
  while (string[i] != '\0'){
    if (string[i] == '\n'){
      string[i] = '\0';
      break;
    }
    i++;
  }
}
#endif
